> For the complete documentation index, see [llms.txt](https://docs.apryse.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.apryse.com/uwp/security/custom-handler.md).

# Apryse Custom Security Handler in UWP

Discover how the Apryse Custom Security Handler encrypts files for Digital Rights Management (DRM) with ease. Learn about encryption methods and unique custom IDs for enhanced security. Explore sample

The Apryse Custom Security Handler provides a means to encrypt files in a way that cannot be decrypted by other applications. This makes it especially suitable for Digital Rights Management (DRM) use cases. This is an alternative to defining your own custom encryption method. In particular using the Apryse Custom Security Handler is much simpler as it comes built-in with Apryse SDK.

Like other encryption methods a password is required to encrypt and decrypt the document. This custom security handler also requires the application choose a unique unsigned integer custom id (typically one per application) of their choice to encrypt and decrypt the document. Using this unique id provides an extra level of security as even other applications based on Apryse SDK will not typically be configured to open files secured with that particular id.

## Encrypting an Apryse Custom secured document using the password and application custom id

The first step before encrypting is to choose an application custom id. A typical way to create this is to use a random generator to create a 32-bit number. This number would then be used throughout your document workflow.

Once that is done, the document can be encrypted:

{% tabs %}
{% tab title="C#" %}
{% code lineNumbers="true" %}

```csharp
// Open the document
PDFDoc doc = new PDFDoc(filename);

// Create Apryse custom security handler with a custom id. Replace this with your own integer
PDFTronCustomSecurityHandler custom_handler = new PDFTronCustomSecurityHandler(my_custom_id);

// Set a new password required to open a document
custom_handler.ChangeUserPassword(my_password);

// Note: document takes the ownership of custom_handler.
doc.SetSecurityHandler(custom_handler);

// Save the encrypted document
doc.Save(output_filename, SDFDoc.SaveOptions.e_remove_unused);
```

{% endcode %}
{% endtab %}
{% endtabs %}

[Encrypt and Decrypt PDF Files](/uwp/get-started/samples.md#encryption) Full sample code which illustrates some of our encryption support.

## Decrypting an Apryse Custom secured document using the password and application custom id

The same application custom id and password using during encryption are required for decryption. Failing to provide the correct password or application custom id will prevent opening the encrypted document.

To decrypt a PDF with Apryse Custom security:

{% tabs %}
{% tab title="C#" %}
{% code lineNumbers="true" %}

```csharp
// Register the Apryse Custom Security handler with the same custom id used in encryption.
// Calling this function is a requirement to load files encrypted with PDFTronCustomSecurityHandler.
PDFNet.AddPDFTronCustomHandler(my_custom_id);

PDFDoc doc_enc = new PDFDoc(filename);
if (doc_enc.InitStdSecurityHandler(my_password)) {
  // The password is correct! Document can now be used for reading and editing
}
```

{% endcode %}
{% endtab %}
{% endtabs %}

[Encrypt and Decrypt PDF Files](/uwp/get-started/samples.md#encryption) Full sample code which illustrates some of our encryption support.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.apryse.com/uwp/security/custom-handler.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
